unit Unit1;

interface

uses Windows, SysUtils, Messages, Unit2;

const
  PARSE_FUNCTION: AnsiString = 'MULTIMEDIA & (EXT="VOB"|EXT="MPG"|EXT="MPEG"' +
    '|EXT="OGV"|EXT="MP4"|EXT="M4V"|EXT="MKV"|EXT="WMV"|EXT="AVI"|EXT="ASF"' +
    '|EXT="FLV"|EXT="MOV")';

  lc_copy=1;
  lc_newparams=2;
  lc_selectall=3;
  lc_setpercent=4;

  lcp_wraptext=1;
  lcp_fittowindow=2;
  lcp_ansi=4;
  lcp_ascii=8;
  lcp_variable=12;
  lcp_forceshow=16;

  lcs_findfirst=1;
  lcs_matchcase=2;
  lcs_wholewords=4;
  lcs_backwards=8;

  itm_percent=$FFFE;
  itm_fontstyle=$FFFD;
  itm_wrap=$FFFC;
  itm_fit=$FFFB;
  itm_next=$FFFA;

  LISTPLUGIN_OK=0;
  LISTPLUGIN_ERROR=1;

type
  tListDefaultParamStruct = record
    size,
    PluginInterfaceVersionLow,
    PluginInterfaceVersionHi:longint;
    DefaultIniName:array[0..MAX_PATH-1] of AnsiChar;
  end;
  pListDefaultParamStruct=^tListDefaultParamStruct;

  function ListLoad(ParentWin:THandle;FileToLoad:pansichar;ShowFlags:integer):THandle; stdcall;
  function ListLoadW(ParentWin:THandle;FileToLoad:pchar;ShowFlags:integer):THandle; stdcall;
  procedure ListCloseWindow(ListWin: THandle); stdcall;
  function ListSendCommand(ListWin:THandle;Command,Parameter:integer):integer; stdcall;
  procedure ListGetDetectString(DetectString: pansichar; maxlen: integer); stdcall;
  procedure ListSetDefaultParams(dps: pListDefaultParamStruct); stdcall;
  procedure UnloadPlugin;

implementation

var
  hinst: NativeUInt = 0;
  NativeWidth, NativeHeight: Integer;
  PluginInitialized: Boolean;


Function WindowProc(Window: hWnd; Msg: Cardinal; WPARAM: WPARAM; LParam: LPARAM): NativeInt; StdCall;
  var dc: HDC;
      WRec: TRect;
      brush: HBRUSH;
      ps: TPaintStruct;
      tmp: TMPdata;
      int: NativeInt;

      CmdStr: string;
      MPdata: PTMPdata;
Begin
  Result := 0;
  Case Msg of
    WM_NCPAINT : begin
                dc:=BeginPaint(Window,ps);
                GetClientRect(Window,WRec);
                brush:=CreateSolidBrush($00101010);
                SelectObject(dc, brush);
                FillRect(dc,WRec,brush);
                EndPaint(Window,ps);
                DeleteObject(brush);
               end;
    WM_CLOSE : PostQuitMessage(0);
    WM_KEYDOWN  :
        begin
          int:=GetWindowLong(Window,GWL_USERDATA);
          tmp:= int2TMPdata(int);
          MPdata := PTMPdata(Pointer(int));
          case WParam of
            VK_SPACE  : SendCommand(tmp,'pause');
               VK_UP  : SendCommand(tmp,'seek +60');
             VK_DOWN  : SendCommand(tmp,'seek -60');
            VK_RIGHT  : SendCommand(tmp,'seek +10');
             VK_LEFT  : SendCommand(tmp,'seek -10');
                  81  : begin
                          SendCommand(tmp,'quit');
                          PostMessage(GetParent(Window),WM_CLOSE,0,0);
                        end;
                  57  : SendCommand(tmp,'volume -1');
           VK_DIVIDE  : SendCommand(tmp,'volume -1');
                  48  : SendCommand(tmp,'volume +1');
         VK_MULTIPLY  : SendCommand(tmp,'volume +1');
                 186  : SendCommand(tmp,'brightness -1');
                 222  : SendCommand(tmp,'brightness +1');
            Ord('I')  : begin
                          ReadAllPipe(tmp.ReadPipe);
                          SendCommand(tmp,'osd_show_progression');
                          {
                          SendCommand(tmp,'get_video_codec');
                          MessageBox(Window, PChar(ReadAllPipe(tmp.ReadPipe, True)), nil, 0);
                          }
                        end;
            Ord('M')  : begin
                          MPdata^.MSettings.Mute := not MPdata^.MSettings.Mute;
                          CmdStr := Ord(MPdata^.MSettings.Mute).ToString;
                          SendCommand(tmp, 'mute ' + CmdStr);
                        end;
            Ord('H')  : begin
                          MPdata^.MSettings.Loop := not MPdata^.MSettings.Loop;
                          if not MPdata^.MSettings.Loop then
                            CmdStr := '-1'
                          else
                            CmdStr := '1';
                          SendCommand(tmp, 'loop ' + CmdStr);
                        end;
          end;
        end;
  Else Result := DefWindowProc(Window,Msg,WParam,LParam);
  End;
End;

function ListLoad(ParentWin:THandle;FileToLoad:pansichar;ShowFlags:integer):THandle; stdcall;
begin
  Result := 0;
end;

function ListLoadW(ParentWin:THandle;FileToLoad:pchar;ShowFlags:integer):THandle; stdcall;
      var CmdLine : string;
               si : TStartupInfo;
               pi : TProcessInformation;
       DummyPipe1,
       DummyPipe2 : NativeUInt;
              sec : TSecurityAttributes;
           hMyWin : HWND;
    ClientProcess,
         ReadPipe,
        WritePipe : NativeUInt;
              tmp : TMPdata;
              ptm : PTMPdata;
      FirstChance : bool;
                r,
                r1 : TRect;
             MPlayer_path,
             MPlayer_params,
             size:string;
             QuickView:Boolean;
             NHeight,NWidth:Integer;

begin
  Result := 0;
  FirstChance:=true;

  if hinst = 0 then
    Exit;


  hMyWin:=CreateWindow('MPWinClass', 'MPWin', WS_CHILD or WS_VISIBLE, 0, 0, 0,
                      0, ParentWin, 0, hinst, nil);

  ParseIniFile(ExtractFilePath(GetModuleName(hInstance))+'mplayer4tc.ini',MPlayer_path,MPlayer_params,size);

  QuickView:= GetParent(ParentWin)<>0;

  if QuickView then
      CmdLine:=EscapeParam(MPlayer_path) + MPlayer_params + ' -quiet -slave -identify'
          +' -wid '+IntToStr(hMyWin) + ' -colorkey 0x101010'
          +#32+EscapeParam(FileToLoad)
                else
      CmdLine:=EscapeParam(MPlayer_path) + MPlayer_params + ' -quiet -slave -identify'
          +' -keepaspect -wid '+IntToStr(hMyWin) + ' -colorkey 0x101010'
          +#32+EscapeParam(FileToLoad);

  with sec do begin
    nLength:=sizeof(sec);
    lpSecurityDescriptor:=nil;
    bInheritHandle:=true;
  end;
  CreatePipe(ReadPipe,DummyPipe1,@sec,0);

  with sec do begin
    nLength:=sizeof(sec);
    lpSecurityDescriptor:=nil;
    bInheritHandle:=true;
  end;
  CreatePipe(DummyPipe2,WritePipe,@sec,0);

  FillChar(si,sizeof(si),0);
  si.cb:=sizeof(si);
  si.dwFlags:=STARTF_USESTDHANDLES;
  si.hStdInput:=DummyPipe2;
  si.hStdOutput:=DummyPipe1;
  si.hStdError:=DummyPipe1;

  //MessageBox(GetActiveWindow, PChar(CmdLine), nil, 0);

  if not CreateProcess(nil,PChar(CmdLine),nil,nil,true,DETACHED_PROCESS,nil,nil,si,pi) then
    begin
      MessageBox(0, PChar(Format('Cannot create process: %s', [MPlayer_path])),
        'mplayer4tc' , MB_ICONEXCLAMATION or MB_OK);
      Result:=0;
      CloseHandle(ReadPipe);
      CloseHandle(WritePipe);
      CloseHandle(DummyPipe1);
      CloseHandle(DummyPipe2);
      DestroyWindow(hMyWin);
      Exit;
    end;


  CloseHandle(DummyPipe1);
  CloseHandle(DummyPipe2);
  {
  if DuplicateHandle(GetCurrentProcess(), pi.hProcess,
    GetCurrentProcess(), @ClientProcess, 0, False, DUPLICATE_SAME_ACCESS) then
    MessageBox(0, PChar('dup handle'), nil, 0);
  }
  ClientProcess:=pi.hProcess;

  //CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);

  tmp.ClientProcess:=ClientProcess;
  tmp.WritePipe:=WritePipe;
  tmp.ReadPipe:=ReadPipe;
  tmp.FirstChance:=FirstChance;

  GetWidthHeight(ReadPipe, NativeHeight, NativeWidth);

  if (not QuickView) and (NativeWidth > 0) and (NativeHeight > 0) then
    begin
      GetWindowRect(ParentWin,r);
      GetClientRect(GetDesktopWindow,r1);
      if size='normal' then
         MoveWindow(ParentWin, round((r1.Left+r1.Right-NativeWidth-8)/2),
                    round((r1.Top+r1.Bottom-NativeHeight-46)/2), NativeWidth+8,
                    NativeHeight+46, true);
      if size='double' then
         MoveWindow(ParentWin, round((r1.Left+r1.Right-NativeWidth*2-8)/2),
                    round((r1.Top+r1.Bottom-NativeHeight*2-46)/2), NativeWidth*2+8,
                    NativeHeight*2+46, true);
      if size='scale_height' then
         MoveWindow(ParentWin, round((r1.Left+r1.Right-(r.Right-r.Left))/2),
                    round((r1.Top+r1.Bottom-(r.Right-r.Left-8)*NativeHeight/NativeWidth-46)/2),
                    r.Right-r.Left, round((r.Right-r.Left-8)*NativeHeight/NativeWidth)+46,true);
      if size='scale_width' then
         MoveWindow(ParentWin, round((r1.Left+r1.Right-((r.Bottom-r.Top-46)*NativeWidth/NativeHeight)-8)/2),
                    round((r1.Top+r1.Bottom-(r.Bottom-r.Top))/2),
                    round((r.Bottom-r.Top-46)*NativeWidth/NativeHeight)+8, r.Bottom-r.Top,true);
      if size='smart' then
         begin
            NHeight:=r.Bottom-r.Top;
            NWidth:=round((r.Bottom-r.Top-46)*NativeWidth/NativeHeight)+8;
            if NWidth>0.7*(r1.Right-r1.Left) then
              begin
                NHeight:=round((r.Right-r.Left-8)*NativeHeight/NativeWidth)+46;
                NWidth:=r.Right-r.Left;
              end;
            MoveWindow(ParentWin,round((r1.Left+r1.Right-NWidth)/2),round((r1.Top+r1.Bottom-NHeight)/2),
                        NWidth, NHeight, true)
         end;
    end;

  tmp.MSettings.Loop := False;
  tmp.MSettings.Mute := False;

  //ptm:=AllocMem(sizeof(tmp));
  New(ptm);
  ptm^ := tmp;
  SetWindowLong(hMyWin, GWL_USERDATA, LONG_PTR(ptm));
  SetFocus(hMyWin);
  Result:=hMyWin;

  if (NativeWidth = -1) and (NativeHeight = -1) then
  begin
    ListCloseWindow(hMyWin);
    Result := 0;
  end;
end;

procedure ListCloseWindow(ListWin: THandle); stdcall;
    var hdc:NativeUInt;
        tmp:TMPdata;
        int:NativeInt;
begin
   int:=GetWindowLong(ListWin,GWL_USERDATA);
   tmp:=int2TMPdata(int);
   ForceStop(tmp);
   hdc:=GetDC(ListWin);
   ReleaseDC(ListWin, hDC);
   DestroyWindow(ListWin);
   CloseHandle(tmp.ReadPipe);
   CloseHandle(tmp.WritePipe);
   CloseHandle(tmp.ClientProcess);
   //FreeMem(pointer(int));
   Dispose(PTMPdata(int));
end;

function ListSendCommand(ListWin:THandle;Command,Parameter:integer):integer; stdcall;
  var tmp:TMPdata;
      int:NativeInt;
begin
  int:= GetWindowLong(ListWin,GWL_USERDATA);
  tmp:=int2TMPdata(int);
  if Command=lcp_fittowindow then SendCommand(tmp,'vo_fullscreen');
  Result:=LISTPLUGIN_OK;
end;

procedure ListGetDetectString(DetectString: pansichar; maxlen: integer); stdcall;
begin
  StrLCopy(DetectString, PAnsiChar(PARSE_FUNCTION), MaxLen - 1)
end;

procedure ListSetDefaultParams(dps: pListDefaultParamStruct); stdcall;
var
  WC : TWndClass;
begin
  if not PluginInitialized then
  begin
    hinst := HInstance;

    With WC do Begin
      Style := CS_OWNDC;
      lpfnWndProc := @WindowProc;
      cbClsExtra := 0;
      cbWndExtra := SizeOf(Pointer);
      hIcon := LoadIcon(0, IDI_WINLOGO);
      hCursor := LoadCursor(0, IDC_ARROW);
      hbrBackground := 0;
      lpszMenuName := nil;
      lpszClassName := 'MPWinClass';
      hInstance := hinst;
    end;

    Windows.RegisterClass(WC);

    PluginInitialized := True;
  end;
end;

procedure UnloadPlugin;
begin
  if hinst <> 0 then
    Windows.UnregisterClass('MPWinClass',HInstance);
end;

end.
